# DABUSB Makefile Standaloneversion
# $Id: Makefile.st,v 1.2.2.8 2005/01/15 01:29:39 acher Exp $

CC	= sdcc #-2.3.0
CFLAGS	=  --debug $(ST_FLAGS) --code-loc 0x100 --xram-loc 0x1d00 --data-loc 0x18 
AS	= asx8051
ASFLAGS	= -plosgff

all:	 main_a.ihx

main_a.ihx: main_a.rel io_x.rel menu_a.rel dabusb_a.rel  io.rel  fpga_a.rel \
	figs_ax.rel  control_a.rel control_ax.rel  storage_ax.rel 
	$(RM) main_a.cdb
	$(CC) --nostdlib   $(CFLAGS) $^ 

%.rel %.asm:	%.c
	$(CC) $(CFLAGS) -c $<

%.rel:	%.asm
	$(AS) $(ASFLAGS) $< ;echo $?


clean:
	$(RM) dabusb_a.{asm,lst,map,rel,rst,sym}
	$(RM) dfire_a.{asm,lst,map,rel,rst,sym}
	$(RM) io.{asm,lst,map,rel,rst,sym}
	$(RM) io_x.{lst,map,rel,rst,sym}
	$(RM) control.{asm,lst,map,rel,rst,sym}
	$(RM) control_a.{asm,lst,map,rel,rst,sym}
	$(RM) control_ax.{lst,map,rel,rst,sym}
	$(RM) menu_a.{lst,map,rel,rst,sym}
	$(RM) fpga_a.{asm,lst,map,rel,rst,sym}
	$(RM) dispatcher.{asm,lst,map,rel,rst,sym}
	$(RM) main_a.{ihx,s19,lnk,lst,rst,map,rel,sym}
	$(RM) temp.lnk


dabusb_a.rel: 	dabusb_a.c 	variables_a.h hw_variables.h io.h control_a.h defines_t.asm 
control_a.rel: 	control_a.c 	variables_a.h hw_variables.h io.h control_a.h defines_t.asm 
dfire_a.rel: 	dfire_a.c 	variables_a.h hw_variables.h io.h control_a.h defines_t.asm
fpga_a.rel: 	fpga_a.c 	variables_a.h hw_variables.h  defines_t.asm 
io.rel: 	io.c 		variables_a.h hw_variables.h defines_t.asm 
io_x.rel: 	io_x.asm 	variables_a.h hw_variables.h io.h control_a.h defines_t.asm
control_ax.rel: control_ax.asm io.h control_a.h defines_t.asm 
menu_a.rel:	menu_a.asm io.h control_a.h defines_t.asm
storage_ax.rel:		storage_ax.asm io.h control_a.h defines_t.asm
figs_ax.rel:		figs_ax.asm io.h control_a.h defines_t.asm
