// control.c 260699 GA
//
//
//   $Id: control.c,v 1.7.2.5 2001/08/20 22:17:19 acher Exp $

#include "regezusb.h"
#pragma SAVE
#pragma NOOVERLAY

typedef unsigned char uchar;
#include "io.h"
#include "variables.h"

void init_dac(void);
void set_volume(void);
void mute_dac(void);
void wait_0_1ms(void);
void select_prog(uchar n,uchar m);

extern uchar xvolume,subch;
extern uchar prog_set,lcd_cont,show_vol;
extern uchar num_sub,num_sub_temp;

/*-------------------------------------------------------------------*/
//! clears name and subchannel list
void init_control(void)
{
	uchar n;
	for(n=0;n<16;n++)
	{
		names[n][0]=0;
		subchannels[n]=0;
	}
}
/*-------------------------------------------------------------------*/
//! prepares for dfire message
void setz(void)
{
	dfire[1016]=0;
	dfire[1017]=0;
	dfire[1018]=0;
	dfire[1019]=0;
	dfire[1023]=0;
}
/*-------------------------------------------------------------------*/
void dac_startup(void)
{
	xilinx0=0x40|lcd_cont;
	wait_1000();
	init_dac();
	xilinx0=0x50|lcd_cont;
	wait_0_1ms();
	mute_dac();
	xilinx0=0x50|lcd_cont;
	wait_1000();
	show_vol=0;


	wait_1000(); 	
	set_volume();
	xilinx0=(lcd_cont|0x50)&~0x40 ;
	show_vol=1;
}
/*-------------------------------------------------------------------*/
//! DF1 select_subchannel CMD
void select_subch(uchar n)
{
	uchar i;
	char* z;
  
	xilinx0=0x10|0x40|lcd_cont;
	wait_0_1ms();
	mute_dac();
	wait_0_1ms();

	//  for(i=0;i<255;i++) wait_0_1ms();
#if 1
	setz();
	i=dfire[0x3ff];
	
	z=cpubuf;
	*z++=1;
	*z++=6;
	*z++=0;
	*z++=0xb;
	*z++=8;
	*z++=1;
	*z++=0;
	*z++=3;
	for(i=0;i<6;i++)
		*z++=0;
	
	*z++=n;
	
	dfire[0x3f9]=15;
	dfire[0x3fe]=1;
	wait_1000();
	wait_1000();
	dac_startup();
#endif
}
/*-------------------------------------------------------------------*/
//! display ensemble/number/name
void show_name(void)
{
	if (ensemble[0])
	{	
		poscursor00();
		print_spaces(16);
		poscursor00();
		printf(ensemble);			
	}
	else
	{
		poscursor00();
		print_spaces(13);
	}

	if (ensemble[0])
                printf(ensemble);

	if (show_vol)
        {
                poscursor(12,0);
                putc(' ');
                putc('P');
                printi(subch+1,2);
        }

	clr_line1();	
        printf(names[subch]); 
}
/*-------------------------------------------------------------------*/
//! copy name from USB packet
void set_name(void)
{
	uchar i,n;

	i=OUT2BUF[1];
	if (i==0 && OUT2BUF[2]==255)
	{
		for(n=0;n<16;n++)
			ensemble[n]=OUT2BUF[4+n];
		ensemble[16]=0;
		num_sub_temp=15;
	}
	else if (i==0 && OUT2BUF[2]==254)
	{
		show_vol=0;
		show_name();
		show_vol=1;
		num_sub=num_sub_temp;
		if (!prog_set)
		{
//			select_prog(subch,0);
//			prog_set=1;
		}
	}
	else
	{
		subchannels[i]=OUT2BUF[2];
		for(n=0;n<16;n++)
			names[i][n]=OUT2BUF[4+n];
		num_sub_temp=i;
	}
}
/*-------------------------------------------------------------------*/
//! select subchannel via array lookup
/*! mode m: 0 : Really change audio (channels range from 0 to 15)
  m: 1: No audio change, 1...16, no lookup
  m: 2: 0...15 lookup names via subchannels (remote mode)*/
void select_prog(uchar n,uchar m)
{
	uchar k;
	show_vol=2;
	if (m!=2)
		show_name();
	else 
	{
		for(k=0;k<16;k++)
			if (n==subchannels[k])
			{
				subch=k;
				show_name();
			}
	}

	if (m==0) 
	{
		n=n&0xf;
		
		select_subch(subchannels[n]);		
	}
	show_vol=1;
}
/*-------------------------------------------------------------------*/
