// control_a.c 140400 GA
//
//
//   $Id: control_a.c,v 1.20.2.21 2005/01/15 01:29:39 acher Exp $

#include "regezusb.h"
#pragma SAVE
#pragma NOOVERLAY

typedef unsigned char uchar;

#include "io.h"
#include "control_a.h"
#include "variables_a.h"

void init_dac(void);
void set_volume(void);
void mute_dac(void);
void wait_0_1ms(void);
uchar read_nvram(void);
void write_nvram(void);

extern uchar xvolume,band,channel,menu,lbmode;
extern uchar key,last_key,xkey,subch;
extern uchar current_band, current_channel,current_subch;
extern uchar bank,storage,supress_bar,lcd_cont,quality;
extern uchar num_sub;

extern uchar hour,min,sec,utc_off;

uchar waiting1,waiting2,start_channel;

#define MSGREG_DAB      0x3ff           // Message from DAB Module to Controller
#define MSGREG_CPU      0x3fe           // Message from Controller to DAB Module
#define DATA_TYPE       0x3fd           // Data Type of BUFFPTR_FIC 0:empty 1:FIC 2:PAD 
#define FREEPTR_DAB     0x3fb           // First free field in circular buffer DAB Module -> Controller
#define DATAPTR_DAB     0x3fa           // Lowest used field in circular buffer DAB Module -> Controller
#define BUFFPTR_DAB     768             // circular buffer DAB Module -> Controller
#define FREEPTR_CPU     0x3f9           // First free field in circular buffer Controller -> DAB Module
#define DATAPTR_CPU     0x3f8           // Lowest used field in circular buffer -> DAB Module
#define BUFFPTR_CPU     960             // circular buffer Controller -> DAB Module
#define BUFSIZE_CPU     32              // size in bytes
#define BUFFPTR_DAB     768             // circular buffer DAB Module -> Controller
#define BUFSIZE_DAB     192             // size in bytes
#define BUFFPTR_FIC     0               // FIC/PAD Databuffer
#define BUFSIZE_FIC     768             // size in bytes


//extern const uchar bandl[26*2];
//extern const uchar  band3[10*4*2];

extern xdata uchar bandl[26*2];
extern xdata uchar  band3[10*4*2];

uchar msglen;
extern uchar timeout;
/*-------------------------------------------------------------------*/
void wait_for_key()
{
	while(1)
	{
		wait_0_1ms();
		if (key) break;
	}
	wait_key_release0();
	key=0;
}
/*-------------------------------------------------------------------*/
extern void init_control(void);
#if 0
{
	uchar n;

	clear_sids();
	ensemble[0]=0;
	dc_data=dc_free=0;
	for(n=0;n<64;n++)
	{
		ensembles[n][0]=0;
		ensembles[n][1]=0xff;
	}
}
#endif

/*-------------------------------------------------------------------*/
uchar temp_x;
void select_subch(uchar n, uchar m)
{
	temp_x=n;
	if (m)
	{
		xilinx0=lcd_cont+64; 
		wait_0_1ms();
		mute_dac();
	}
	Cdfire_start_cmd(&dfc_select_subch);

	_asm;		
	mov dptr,#_cpubuf+14;
	mov a,_temp_x;           //_select_subch_PARM_1;
	movx @dptr,a;

	lcall _set_cd_msg;
	_endasm;

	waiting1=STR_NULL; 

	Cdfire_wait(4,0);
	if (m)
	{
		wait_1000();		
		init_dac();
		mute_dac();
		wait_1000();
		xilinx0=lcd_cont;
	}
	supress_bar=1;
	set_volume();	
	supress_bar=0;

}
/*-------------------------------------------------------------------*/
extern void show_channel();
#if 0
{
	if (band==0)
	{
		if (channel<32)
		{
			printi((channel/4)+5,2);
			Cputc('A'+(channel&3));			
		}
		else 
		{
			printi(13,2);
			Cputc('A'+(channel-32));
		}
	}
	else
	{
		Cputc(' ');
		Cputc('L');
		Cputc('A'+channel);
	}
}
#endif
/*-------------------------------------------------------------------*/
extern void dfire_tune(void);

/*-------------------------------------------------------------------*/
extern void show_name(uchar n);
/*-------------------------------------------------------------------*/
void select_prog(uchar n,uchar m)
{
	uchar k=1;

	Ccurrent_2_NVC();

	Cshow_name(n);	
	show_prognum013();

	if (m==0) 
	{
		n=n&0xf;
		if (current_subch==n)
			k=0;
		select_subch(subchannels[n],k);
	}

	current_subch=n;
}

/*-------------------------------------------------------------------*/
#if 0
void hxdump(uchar m)
{ 
	uchar n;
	Cposcursor(0,0);
	for(n=0;n<16;n++)
		printh(dfire[BUFFPTR_DAB+n+m+16*subch]);
}
#endif

/*-------------------------------------------------------------------*/
void get_dab_status(void)
{
	timeout=40;
	Cdfire_start_cmd(&dfc_get_dabstatus);
	set_cd_msg();
}
/*-------------------------------------------------------------------*/
// Frequency -> channel number
void search_channel()
{
	_asm;
	mov dptr,#_frequ_m;
	movx a,@dptr;
	mov r1,a; /* r1:frequ_m */

	inc dptr;
	movx a,@dptr;
	mov r2,a; /* r2:frequ_l */

	mov r5,#40;
	mov dptr,#_band3;
	mov _band,#0

	mov a,r1
	anl a,#0xf0
	cjne a,#0x60,_sc_band3;

	mov r5,#26;
	mov dptr,#_bandl;
	mov a,_lbmode;
	anl a,#1;
	cjne a,#0,_sc_can;
	mov dptr,#_bandl_can;
_sc_can:
	inc _band

_sc_band3:

	mov r0,#0;
sloop:
	movx a,@dptr;
	mov r3,a;
	inc dptr;
	movx a,@dptr;
	mov r4,a;
	inc dptr;
	mov a,r1;
	cjne a,ar3,sloop_next;
	mov a,r2;
	cjne a,ar4,sloop_next;
	mov _channel,r0;
	ret;
sloop_next:
	inc r0;
	mov a,r0
	cjne a,ar5,sloop;
	mov _channel,#0;
	_endasm;
}
/*-------------------------------------------------------------------*/
extern void transfer_frequ(uchar n);
/*-------------------------------------------------------------------*/
extern void show_dabstate(void);
/*-------------------------------------------------------------------*/
extern void scan_next(void);
/*-------------------------------------------------------------------*/
// sets bank etc. after scan/tune
void setup_storage_bank(void)
{
	storage=find_banked();		
	select_prog(subch,0);
//	bank=(storage-1)/6;
	_asm;
	mov a,_storage;
	dec a;
	mov b,#6;
	div ab;
	mov _bank,a;
	_endasm;
	if (storage!=255)
		bank&=15;
	else
		bank=0;
	show_bank_leds();
	Ccurrent_2_NVC();
}
/*-------------------------------------------------------------------*/
void show_band()
{
        poscursor01();
       	if (band==0)
		Cprintf_index(STR_BAND3);
	else
		Cprintf_index(STR_LBAND);
}
/*-------------------------------------------------------------------*/
void after_tune_1(void)
{
	uchar n;

	utc_off=0;
	hour=min=sec=0;

	clear_sids();
	wait_3000();
	for(n=0;n<4;n++)
	{
		show_dabstate();
		if (quality<5)
		{
			break;
		}
		wait_1s();
	}
	wait_3000();
	get_subch_info();
	show_num_subch();
	wait_1s();
}
/*-------------------------------------------------------------------*/
void after_tune()
{
	after_tune_1();
	subch=0;
	ensemble[0]=0;
	if (quality>1)
		wait_3000();
	setup_storage_bank();
}
/*-------------------------------------------------------------------*/
void do_scan()
{
	menu=0;
	clear_lcd();
	show_band();
	wait_3000();
	scan_next();
	wait_3000();
	after_tune();
}
/*-------------------------------------------------------------------*/
void store_program(uchar n)
{
        poscursor00();
        Cprintf_index(STR_STORED);
	Ccurrent_2_scratch(1);
	Cscratch_2_NVS(1,n);
	wait_3000();
}
/*-------------------------------------------------------------------*/
uchar recall_program(uchar n, uchar waitn)
{
	uchar x;
	
	Ccurrent_2_scratch(1);
	
	CNVS_2_scratch(0,n);
	Cscratch_2_current(0);

	if ((channel!=63)&&(subch<17))
		storage=n;
	else
	{
		current_name[0]=0;
		clr_line1();
		Cprintf_index(STR_NOSTORAGE);
		Cscratch_2_current(1);
		if (waitn)
			wait_1s();
		return 0;
	}
	return 1;
}
/*-------------------------------------------------------------------*/
// 
void recall_chan_sub(void)
{
	uchar m;
//	show_name(subch);

	show_prognum013();
	poscursor01();
	if (storage!=255)
		print_current_name();
	
	if ((channel !=current_channel) ||
	    (band != current_band))
	{
		current_subch=254;
		timeout=160;
		wait_3000();
		dfire_tune();	
		wait_3000();
		Cdfire_wait(4,0xa);

		after_tune_1();
	}
	if (subch>num_sub)
		subch=0;
	
       	wait_3000();
	setup_storage_bank();
	current_channel=channel;
	current_band=band;
}
