// dfire.c 270699 GA
//
// DFIRE communication
//
// $Id: dfire.c,v 1.9.2.1 2001/04/29 00:55:03 acher Exp $

#include "regezusb.h"
#pragma SAVE
#pragma NOOVERLAY

typedef unsigned char uchar;

#include "io.h"

#include "hw_variables.h"

// ------------ DAB-Module registers


#define MSGREG_DAB	0x3ff		// Message from DAB Module to Controller
#define MSGREG_CPU	0x3fe		// Message from Controller to DAB Module
#define DATA_TYPE	0x3fd		// Data Type of BUFFPTR_FIC 0:empty 1:FIC 2:PAD 
#define FREEPTR_DAB	0x3fb		// First free field in circular buffer DAB Module -> Controller
#define DATAPTR_DAB	0x3fa		// Lowest used field in circular buffer DAB Module -> Controller
#define BUFFPTR_DAB	768		// circular buffer DAB Module -> Controller
#define FREEPTR_CPU	0x3f9		// First free field in circular buffer Controller -> DAB Module
#define DATAPTR_CPU	0x3f8		// Lowest used field in circular buffer -> DAB Module
#define BUFFPTR_CPU	960		// circular buffer Controller -> DAB Module
#define BUFSIZE_CPU	32		// size in bytes
#define BUFFPTR_DAB	768		// circular buffer DAB Module -> Controller
#define BUFSIZE_DAB	192		// size in bytes
#define BUFFPTR_FIC	0		// FIC/PAD Databuffer
#define BUFSIZE_FIC	768		// size in bytes

typedef unsigned char uchar;
extern char msg_wait;
extern void wait_0_1ms();
#define DFIRE_ADDR 0x8400

extern uchar dline;

/*-------------------------------------------------------------------*/
//! reads DF2 buffer to USB
void read_module_buf(void)
{
#if 0  
  poscursor(0,2);
  printf("READ ");
  printh(OUT2BUF[3]);
  printf(".");
  printh(OUT2BUF[2]);
  printh(OUT2BUF[1]);
#endif  
#if 1
  _asm
    mov dptr,#_OUT2BUF+1
    movx a,@dptr
    mov r1,a              
    inc dptr
    movx a,@dptr
    mov r2,a             
    inc dptr
    movx a,@dptr
    mov r3,a
    mov r4,#_IN2BUF
    mov r5,#(_IN2BUF>>8)		 
    mov a,r3
    jz end_loop_r 
loop_r:
    mov _DPL,r1
    mov _DPH,r2
    movx a,@dptr
    inc dptr
    mov r1,_DPL
    mov r2,_DPH
    mov _DPL,r4
    mov _DPH,r5
    movx @dptr,a
    inc r4
    djnz r3,loop_r
end_loop_r:

  mov dptr,#_IN2CS;
  mov a,#2;
  movx @dptr,a;

  mov dptr,#_OUT2BUF+3;
  movx a,@dptr;
  mov dptr,#_IN2BC;
  movx @dptr,a;

  mov dptr,#_IN2CS;
  mov a,#2;
  movx @dptr,a;

  mov dptr,#_OUT2BUF+3;
  movx a,@dptr;
  mov dptr,#_IN2BC;
  movx @dptr,a;

    _endasm;
#endif
}
/*-------------------------------------------------------------------*/
//! write DF2 memory via USB
void write_module_buf(void)
{
#if 1
  _asm
    mov dptr,#_OUT2BUF+1
    movx a,@dptr
    mov r1,a              
    inc dptr
    movx a,@dptr
    mov r2,a             
    inc dptr
    movx a,@dptr
    mov r3,a
    mov r4,#_OUT2BUF+4
    mov r5,#((_OUT2BUF+4)>>8)		 
    mov a,r3
    jz end_loop_r 
loop_w:
    mov _DPL,r4
    mov _DPH,r5
    movx a,@dptr
    inc r4
    mov _DPL,r1
    mov _DPH,r2
    movx @dptr,a
    inc dptr
    mov r1,_DPL
    mov r2,_DPH
    djnz r3,loop_w
end_loop_w:
   
    _endasm;
#endif

}
/*-------------------------------------------------------------------*/
//! write to I2C via USB
void write_i2c(void)
{
#if 0
	uchar adr;
	uchar len,n;
	
	len=OUT2BUF[3];
	n=0;
	I2CS=0x80; // START
	I2DAT=OUT2BUF[1];
	wait_done();
	
	I2DAT=OUT2BUF[4];
	wait_done();
	I2DAT=OUT2BUF[5];
	wait_done();
	
	
	I2CS=0x40; // STOP
#else
	_asm;
	clr IE.7;
	
	mov dptr,#_OUT2BUF+1;
	movx a,@dptr; // addr
	mov r2,a;
	inc dptr;
	inc dptr;
	movx a,@dptr; // len
	jz end_write_i2c;
	mov r1,a;
	
	mov dptr,#_I2CS;
	mov a,#0x80;       // START
	movx @dptr,a;

	mov dptr,#_I2DAT;
	mov a,r2;
	movx @dptr,a;      // I2C addr
	lcall _wait_done;

	mov r3,#0;
	
i2c_wloop:
	mov dptr,#_OUT2BUF+4;
	mov a,dpl;
	add a,r3;
	mov dpl,a;
	inc r3;
	movx a,@dptr;
	mov dptr,#_I2DAT;
	movx @dptr,a;
	lcall _wait_done;
	djnz r1,i2c_wloop;
	
	mov dptr,#_I2CS;
	mov a,#0x40;
	movx @dptr,a;
	
       
end_write_i2c:
	setb ie.7;
			       
    _endasm;    
#endif
}
/*-------------------------------------------------------------------*/
//! read I2C via USB
void read_i2c(void)
{
#if 1
	_asm;
	clr IE.7;

	mov dptr,#_OUT2BUF+1;
	movx a,@dptr; // addr
	mov r2,a;
	inc dptr;
	inc dptr;
	movx a,@dptr; // len
	jz end_write_i2c;
	mov r1,a
	
	mov dptr,#_I2CS;
	mov a,#0x80;
	movx @dptr,a;

	mov dptr,#_I2DAT;
	mov a,r2;
	movx @dptr,a;
	lcall _wait_done;
	
	cjne r1,#1,i2c_not1a;
	mov dptr,#_I2CS;
	mov a,#0x20;
	movx @dptr,a;
i2c_not1a:
	mov dptr,#_I2DAT;
	movx a,@dptr;
	lcall _wait_done;
	mov r3,#0;
	mov a,r1
	clr c
	subb a,#1;
	mov r1,a;
	jz i2c_lastbyte;
		
	mov r3,#0;
i2c_rloop:
	cjne r1,#1,i2c_not1;
	mov dptr,#_I2CS;
	mov a,#0x20;
	movx @dptr,a;
i2c_not1:
	mov dptr,#_I2DAT;
	movx a,@dptr;
	mov r2,a;
	lcall _wait_done;
	
	mov dptr,#_IN2BUF;
	mov a,dpl;
	add a,r3;
	mov dpl,a;
	inc r3;
	mov a,r2;
	movx @dptr,a;

	djnz r1,i2c_rloop;

i2c_lastbyte:
	mov dptr,#_I2CS;
	mov a,#0x40;
	movx @dptr,a;

	mov dptr,#_I2DAT;
	movx a,@dptr;
	mov r2,a;
	lcall _wait_done;
	
	mov dptr,#_IN2BUF;
	mov a,dpl;
	add a,r3;
	mov dpl,a;
	inc r3;
	mov a,r2;
	movx @dptr,a;
	
	setb ie.7;
    _endasm;    
#endif
    IN2BC=64;
}
/*-------------------------------------------------------------------*/

/*-------------------------------------------------------------------*/
void read_ee(void)
{


}

