// dispatcher.c 190799 GA
//
//
//   $Id: dispatcher.c,v 1.3.2.3 2004/02/13 19:40:55 acher Exp $

#include "regezusb.h"
#include "usb.h"

#pragma SAVE
#pragma NOOVERLAY

void set_endpoint(char n);
typedef unsigned char uchar;

extern void set_i2s_ep(void);
extern void set_rdi_ep(void);
extern void handle_set_feature(void);
extern void handle_get_feature(void);
extern void printf(char *s);
extern void printh(uchar s);
uchar confignum;
extern uchar ep0_dispatch;
xdata /*at 0x1a20*/ uchar alt_set[4];
extern xdata /*at 0x1a80*/ uchar saved_setup[8];
extern xdata /*at 0x1a88*/ uchar saved_out0buf[8];


xdata at 0x7fb6 uchar INXCTRL[2*7];
xdata at 0x7fc6 uchar OUTXCTRL[2*7];
extern unsigned int monpos;
/*-------------------------------------------------------------------*/
/* COntrol EP0 dispatch */





#define IRQ_PRE     _asm \
                    push _DPS \
                    _endasm; \
                    DPS=0;             

#define IRQ_PREUSB  _asm \
                    push _DPS \
                    _endasm; \
                    DPS=0; \
                    _asm \
	            mov a,_EXIF \
                    clr acc.4 \
                    mov _EXIF,a \
                   _endasm;


#define IRQ_POST    _asm \
	            pop _DPS \
                    _endasm;

#include "descriptor.desc"
/*----------------------------------------------------------------------*/

void usb_sudav_isr(void) interrupt 13
{
  uchar tmp;
  uchar sd0,sd1,n;
  uchar xtmp[16];

  IRQ_PREUSB;
  USBIRQ = 0x01;
#if 0
  printh(SETUPDAT[0]);
  printh(SETUPDAT[1]);
  printh(SETUPDAT[4]);
  printf(" ");
#endif
#if 0
  
  monbuf[monpos]=SETUPDAT[0];
  monbuf[monpos+1]=SETUPDAT[1];
  monbuf[monpos+2]=SETUPDAT[2];
  monbuf[monpos+3]=SETUPDAT[3];
  monbuf[monpos+4]=SETUPDAT[4];
  monbuf[monpos+5]=SETUPDAT[5];
  monbuf[monpos+6]=SETUPDAT[6];
  monbuf[monpos+7]=SETUPDAT[7];


  
  monpos+=8;
  monpos&=511;
  monbuf[monpos]=0xff;

#endif
  sd0=SETUPDAT[0];
  sd1=SETUPDAT[1];


  //---------------------------------------------------------------

  if (sd1==GET_STATUS)  //
    {
      if (sd0==IN_STD_DEV)
	{
	  IN0BUF[0] = 1; /* self powered, no remote wakeup */
	  IN0BUF[1] = 0;
	  IN0BC = 2;
	  goto setupack;
	}
      else if (sd0==IN_STD_ENDPOINT)
	{
	  tmp = SETUPDAT[4];
	  if (tmp >= 1 && tmp <= 7)
	    IN0BUF[0] = 1 & OUTXCTRL[2*(tmp-1)];
	  else if  (tmp >= 0x81 && tmp <= 0x87)
	    IN0BUF[0] = 1 & INXCTRL[2*(tmp-0x81)];
	  else
	    IN0BUF[0] = 0;
	  IN0BUF[1] = 0;
	  IN0BC = 2;
	  goto setupack;
	}
       else if (sd0==IN_STD_INTERFACE)
	 {
	   IN0BUF[0] = 0;
	   IN0BUF[1] = 0;
	   IN0BC = 2;
	   goto setupack;
	 }
       goto setupstall;
    }    // GET_STATUS
 
  //---------------------------------------------------------------
 
  if (sd1==CLEAR_FEATURE) // || SET_CUR
    {
      if (sd0==OUT_STD_DEV)      /* remote wakeup */
	goto setupack;
      else if (sd0==OUT_STD_ENDPOINT)
	{
	  tmp = SETUPDAT[4];
	  set_endpoint(0);
	  goto setupack;
	}
      else if (sd0==OUT_CLASS_INTERFACE)
	{ 	
	    ep0_dispatch=1;
	    OUT0BC=0;
	    goto setupack;
	}
      goto setupack; //setupstall;
    } // CLEAR_FEATURE || SET_CUR

  //---------------------------------------------------------------
 
  if (sd1==SET_FEATURE)  // || SET_MAX
    {
      if (sd0==OUT_STD_DEV) /* remote wakeup */
	goto setupack;
      else  if ((sd0==OUT_STD_ENDPOINT))
	{
	  set_endpoint(1);
	  goto setupack;
	}
      goto setupack;
    } // SET_FEATURE || SET_MAX
  
  //---------------------------------------------------------------

  if (sd1==GET_DESCRIPTOR)
    {
      if (sd0!=IN_STD_DEV)
	goto setupstall;
      if (SETUPDAT[3] == 0x01) 
	{
	  //printf("GET DEVICE  \n");
	  SUDPTRH = ((unsigned int)usb_device_descriptor) >> 8;
	  SUDPTRL = ((unsigned int)usb_device_descriptor);
	  goto setupack;
	}
      if (SETUPDAT[3] == 0x02 && SETUPDAT[2] == 0) 
	{
	  // printf("GET CONFIG  \n");
	  SUDPTRH = ((unsigned int)usb_config0_descriptor) >> 8;
	  SUDPTRL = ((unsigned int)usb_config0_descriptor);
	  goto setupack;
	}
      goto setupstall;
    } // GET_DESCRIPTOR
  
  //---------------------------------------------------------------

  if (sd1==SET_DESCRIPTOR)
     goto setupstall;

  //---------------------------------------------------------------

  if (sd1==GET_CONFIGURATION)
    {
      IN0BUF[0] = confignum; 
      IN0BC = 1;
      goto setupack;
    }
  
  //---------------------------------------------------------------

  if (sd1==SET_CONFIGURATION)
    {
      if (sd0 != 0x00)
		goto setupstall;
      if (SETUPDAT[2] > 0x01)
		goto setupstall;
	if (SETUPDAT[2]==0)
	{
		alt_set[1]=0;
		alt_set[2]=0;
	}
      confignum=SETUPDAT[2];	
      goto setupack;
    }
  
  //---------------------------------------------------------------

  if (sd1==GET_INTERFACE)
    {
      //      printf("GI");
      if (sd0==IN_STD_INTERFACE)
	{
	 n=SETUPDAT[4];
#if 0
	 printf("IF");
	 xtmp[0]=48+n;
	 xtmp[1]=32;
	 xtmp[2]='A';
	 xtmp[3]='S';
	 xtmp[4]=48+alt_set[n];
	 xtmp[5]=0;
	 printf(xtmp);	
#endif
	 IN0BUF[0]=alt_set[n];
	
	  IN0BC=1;
	  goto setupack;
 	}
      goto setupstall;
    }

  //---------------------------------------------------------------

  if (sd1==SET_INTERFACE)
    {
      /*
      printf("IF");
      xtmp[0]=48+SETUPDAT[4];
      xtmp[1]=32;
      xtmp[2]='A';
      xtmp[3]='S';
      xtmp[4]=48+SETUPDAT[2];
      xtmp[5]=0;
      printf(xtmp);
      */
	alt_set[0]=0;
      if ((SETUPDAT[4]==1)&&(SETUPDAT[5]==0))
	{
      	  alt_set[1]=SETUPDAT[2];	  
	  set_i2s_ep();
	}      
          else if ((SETUPDAT[4]==2)&&(SETUPDAT[5]==0))
      {
      	set_rdi_ep();
      	  alt_set[2]=SETUPDAT[2];	  	
      
      }
      TOGCTL=0x12; // clear data toggles
      TOGCTL=0x32;
      TOGCTL=0x12;
      TOGCTL=0x02;
      TOGCTL=0x22;
      TOGCTL=0x02;
      goto setupack;
    }

  
  //---------------------------------------------------------------

  if (sd1==SYNCH_FRAME)
    goto setupstall;

  //---------------------------------------------------------------
 
  if ((sd1==GET_CUR)||(sd1==GET_MAX)||(sd1==GET_MIN)||(sd1==GET_RES))
      {
	handle_get_feature();
	goto setupack;
    }

  //---------------------------------------------------------------
  
 setupstall:
  EP0CS = 3;  /* signal stall */
  goto endusbisr;

setupack:
  EP0CS = 2;  /* clear HSNAK */
  goto endusbisr;

 endusbisr:
  
  IRQ_POST;
}
//------------------------------------------------------------------
void set_endpoint(char n)
{
  volatile uchar tmp;
  char xtmp[16];

  tmp = SETUPDAT[4];

	if ((tmp >= 1) && (tmp <= 7))
		OUTXCTRL[2*(tmp-1)]=n;
	else if  ((tmp >= 0x81) && (tmp <= 0x87))
		INXCTRL[2*(tmp-1)]=n;	
}
