; figs_ax.asm
; FIG Parsing
; $Id: figs_ax.asm,v 1.1.2.6 2001/08/13 20:48:32 acher Exp $

	.module figs_ax
	.include "regezusb.asm"	
	.include "defines_t.asm"

	.globl _parse_all_figs
	.globl _get_sid_dptr

	.area DSEG    (DATA)
_last_tf:
	.ds 1
	
	.area CSEG (CODE)
; -------------------------------------------------------------------

_parse_all_figs:
	mov dptr,#0x8400
	movx a,@dptr
	inc dptr
	cjne a,_last_tf,_parse_it
	ret

_parse_it:
	mov _last_tf,a
	mov r0,#12

_fib_loop:			; Start decoding FIB
	push ar0
	push dph
	push dpl

	mov a,dpl
	add a,#30
	mov dpl,a		; CRC

	movx a,@dptr
	jnz _next_fib		; bad CRC
	inc dptr
	movx a,@dptr
	jnz _next_fib		; bad CRC
				; dptr= new fib
	mov r6,dph
	mov r7,dpl
	pop dpl			; get start again
	pop dph
	push ar6
	push ar7		; store new fib

_fig_loop:			; FIG decoding
	movx a,@dptr		; get fig/length

	cjne a,#0xff,_not_end_marker
	sjmp _next_fib		; FIB done

_not_end_marker:
	mov r2,a

	swap a
	rr a
	anl a,#7
	mov r3,a		; r3= fig type

	mov a,dpl
	anl a,#31
	mov r1,a		; current pos
	
	mov a,r2
	anl a,#31
	inc a
	mov r2,a
	add a,r1		; pos after current fig
	jb acc.5,_next_fib	; >=32?  forget it
		
	push ar2		; current FIG length
	push dph
	push dpl

	inc dptr		; skip hdr

	movx a,@dptr		; extension
	inc dptr

	cjne r3,#0,_not_fig0
				; FIG 0
	lcall _parse_fig_0x
	sjmp _next_fig

_not_fig0:
	cjne r3,#1,_not_fig1
				; FIG 1
	anl a,#15		; oe + extension
	lcall _parse_fig_1x
	sjmp _next_fig

_not_fig1:
				
_next_fig:
	pop dpl
	pop dph
	pop ar1			; FIG length (incl. header)

	mov a,dpl
	add a,r1
	mov dpl,a
	mov a,dph
	addc a,#0
	mov dph,a		; incr dptr+length

	mov a,dpl
	anl a,#31
	cjne a,#31,_fig_loop

_next_fib:
	pop dpl
	pop dph
	pop ar0
	inc dptr
	djnz r0,_fib_loopx

	ret
_fib_loopx:
	ljmp _fib_loop
; -------------------------------------------------------------------
; r0,r1: SIDH/SIDL, r2: start for search  returns a>0: my_subch, a=0xff: not found
_find_sid:
	mov dptr,#_sids
	mov a,dpl
	add a,r2
	add a,r2
	mov dpl,a
_find_sid_loop:
	movx a,@dptr
	inc dptr
	cjne a,ar0,_fs1
	movx a,@dptr
	cjne a,ar1,_fs1
	mov a,r2
	ret
_fs1:
	inc dptr
	inc r2
	cjne r2,#16,_find_sid_loop
	mov a,#255
	ret
; -------------------------------------------------------------------
_get_sid_dptr:
	movx a,@dptr		; sidH
	mov r0,a
	inc dptr
	movx a,@dptr		; sidL
	mov r1,a
	inc dptr
	ret
; -------------------------------------------------------------------
;                FIG 1
; -------------------------------------------------------------------
; a: extension, r2: fig length
_parse_fig_1x:
	cjne r2,#0x16,_not_fig11

	cjne a,#0,_not_fig10
				; FIG 1/0 Ensemble label
	inc dptr
	inc dptr
	movx a,@dptr
	jz _not_fig11
	mov r1,dph
	mov r0,dpl
	mov dptr,#_ensemble	; destination
	ljmp _copy_16bytes	

_not_fig10:
	cjne a,#1,_not_fig11
				; FIG 1/1
	acall _get_sid_dptr	; get sid r0/r1
	mov r3,ar0
	mov r4,ar1
	mov r7,#0
_pf001:
	mov r2,ar7
	push dph
	push dpl
	mov r0,ar3
	mov r1,ar4
	acall _find_sid
	pop dpl
	pop dph
	
	jb acc.7,_not_fig11	; not found

	mov r7,a

	mov r1,dph
	mov r0,dpl		; source@fig11

	swap a			; *16		
	mov dpl,a
	mov dph,#_names>>8
	lcall _copy_16bytes
	inc r7
;	cjne r7,#16,_pf001

_not_fig11:
	ret
; -------------------------------------------------------------------
_exit_fig0xa:
	ret
; -------------------------------------------------------------------
; a: extension, r2: fig length
_parse_fig_0x:
	cjne a,#2,_not_fig02		; cn=oe=pd=0
_fig02:	
	mov a,r2
	clr c
	subb a,#3			; - sid - scid
	jc _exit_fig0xa
	mov r2,a

	acall _get_sid_dptr

	movx a,@dptr
	anl a,#15			; num service components
	cjne a,#13,_pf000
_pf000:
	jnc _exit_fig0xa

	mov r3,a			; r3 : num sc
	inc dptr

_service_loop:

	movx @dptr,a
	inc dptr			; byte 1
	anl a,#0xc0
	jnz _pf_no_audio

	movx a,@dptr			; byte 2
	rr a
	rr a
	anl a,#63
	mov r5,a			; r5: subch

	push dph
	push dpl
	mov dptr,#_subchannels
	mov r4,#0
_pf_find_subch:
	movx a,@dptr
	anl a,#63
	cjne a,ar5,_pf_001
				; subch
	mov dptr,#_sids
	mov a,dpl
	add a,r4
	add a,r4
	mov dpl,a		; =sids[r4]
	mov a,r0
	movx @dptr,a
	inc dptr
	mov a,r1
	movx @dptr,a
	sjmp _pf_002
_pf_001:
	inc dptr
	inc r4
	cjne r4,#16,_pf_find_subch
	
_pf_002:
	pop dpl
	pop dph

_pf_no_audio:
	inc dptr
	dec r2
	dec r2
	mov a,r2
	jz _exit_fig0x			; out of data
	djnz r3,_service_loop
	ljmp _fig02			; rerun
		
_not_fig02:
 .if 1
	cjne a,#0xa,_not_fig0a
					; FIG 0/10 TIME/DATE
	inc dptr
	inc dptr
	movx a,@dptr
	mov r5,a
	anl a,#7
	rl a
	rl a
	mov r3,a
	inc dptr
	movx a,@dptr
	mov r4,a
	rl a
	rl a
	anl a,#3
	orl a,r3
	mov _hour,a
	
	mov a,r4
	anl a,#63
	mov _min,a
	mov _sec,#0

	mov a,r5
	jnb acc.3,_short_utc
	inc dptr
	movx a,@dptr
	rr a
	rr a
	anl a,#63
	mov _sec,a
 .endif
_short_utc:
	ret
_not_fig0a:
	cjne a,#0x9,_not_fig09
	movx a,@dptr			; FIG 0/9 Time zone
	jb acc.6,_not_fig09
	mov _utc_off,a
_not_fig09:
_exit_fig0x:
	ret