#include "regezusb.h"

typedef unsigned char uchar;

#if 1  // LED-MODE
#define FPGA_CLK (0x80+1)
#define FPGA_DATA (0x40+2)
#else 
#define FPGA_CLK 0x01
#define FPGA_DATA 0x02
#endif
extern wait_done();
void printh(uchar s);
void printi(uchar s,uchar i);
extern void wait_0_1ms();
/*-------------------------------------------------------------------*/
void i2c_set_addr_read(void) // ASM-Binding! Addr-H in r2, L in r3
{
	_asm;
	mov dptr,#_I2CS; 
	mov a,#0x80; // Start
	movx @dptr,a;

	inc dptr;        //#_I2DAT;
	mov a,#0xa2;  //addr
	movx @dptr,a;
	lcall _wait_done;

	mov a,r2;
	movx @dptr,a;
	lcall _wait_done;

	mov a,r3;
	movx @dptr,a;
	lcall _wait_done;

	// Start read

	mov dptr,#_I2CS;
	mov a,#0x80;
	movx @dptr,a;

	inc dptr;         //#_I2DAT;
	mov a,#0xa3;
	movx @dptr,a;
	lcall _wait_done;

	movx a,@dptr; //dummy
	lcall _wait_done;

	_endasm;
}
/*-------------------------------------------------------------------*/
void i2c_stop_read (void)
{
	_asm;
	mov dptr,#_I2CS;
	mov a,#0x60;
	movx @dptr,a;

	inc dptr;         //,#_I2DAT;
	movx a,@dptr;
	lcall _wait_done;       
	_endasm;
}
/*-------------------------------------------------------------------*/
void download_fpga(void)
{
	_asm;

	mov r2,#0x7f;
	mov r3,#0xfe;
	lcall _i2c_set_addr_read;
	mov dptr,#_I2DAT;
	movx a,@dptr;
	
	cjne a,#0x42,no_fpga_code;

	lcall _i2c_stop_read;
	
	mov dptr,#_OUTC;   // Clear FPGA
	mov a,#0x30;
	movx @dptr,a;
	lcall _wait_0_1ms;

	mov dptr,#_OUTC;
	mov a,#0x38;
	movx @dptr,a;

	mov r1,#255;
clear_loop:
	lcall _wait_0_1ms;
	djnz r1,clear_loop;

	mov r2,#0x50;  // Start
	mov r3,#0x4a;
	lcall _i2c_set_addr_read;

	clr a;
	mov r3,a;
	mov r4,a;

fpga_loop1:
	mov dptr,#_I2DAT;
	movx a,@dptr;
	mov r1,a; // next x

;	push ar4;
	lcall _wait_done;
;	pop ar4;

	mov r5,#8; // bit counter
	mov  dptr,#_OUTA;
fpga_loop2:
	mov a,r1;
	jnb acc.7,fpga_out0;

	mov  a,#FPGA_DATA;
	sjmp nextbit;
fpga_out0:
	clr  a;
nextbit:
	movx  @dptr,a;
	add a,#FPGA_CLK
	movx  @dptr,a;
	mov a,r1;
	rl a
	mov r1,a;
	djnz r5,fpga_loop2;

nextx:

	mov a,r3;
	add a,#1;
	mov r3,a;

	mov a,r4;
	addc a,#0;
	mov r4,a;

	cjne a,#0x2f,fpga_loop1;
	mov a,r3;
	cjne a,#0x00,fpga_loop1;
		
no_fpga_code:
	lcall _i2c_stop_read;


	mov dptr,#_OUTC;
	mov a,#0x18;
	movx @dptr,a;
	_endasm;

}

