// hw_variables.h 290500 GA
//
// HW-variables in external memory (STANDALONE/USB)
//
// $Id: hw_variables.h,v 1.2.2.4 2004/02/14 16:07:56 acher Exp $

// Xilinx memory

xdata at 0x8800 volatile uchar xilinx0;  // subframe counter reset (R)
xdata at 0x8801 volatile uchar xilinx1; // LCD CMD
xdata at 0x8802 volatile uchar xilinx2; // LCD CMD
xdata at 0x8803 volatile uchar xilinx3;  // LCD DATA
xdata at 0x8804 volatile uchar xilinx4;  // read mint
xdata at 0x8809 volatile uchar fifo0_clear;  // I2S clear
xdata at 0x880a volatile uchar fifo1_clear;  // RDI clear
xdata at 0x880b volatile uchar fifo01_clear;  // I2S/RDI clear
xdata at 0x880f volatile uchar xreset;  // 


// DFIRE memory
xdata at 0x8400 volatile uchar dfire[1024];
xdata at 0x87c0 uchar cpubuf[128];  // CPU to DFIRE

xdata at 0x87f9 uchar cd_free;
xdata at 0x87f8 uchar cd_data;
xdata at 0x87fe uchar cd_msg;

xdata at 0x87fa uchar dc_data;
xdata at 0x87fb uchar dc_free;

#define NV_BANK0	0x40
#define NV_SUBCH	1
#define NV_CHANNEL	2
#define NV_BAND		3
#define NV_STORAGE	4


#define NV_VOL		0x10
#define NV_BASS		0x11
#define NV_MID		0x12
#define NV_TREBLE	0x13

#define NV_CONTROL      0x20
#define NV_LBMODE       0x21

// subch/channel/band storage (2 bytes for each storage)
#define NV_BANK1	0x41

#define NV_BANK2	0x42
#define NV_BANK3	0x43

// Name storage (16 bytes)
#define NV_BANK4	0x44
#define NV_BANK5	0x45


// xilinx 0 control register

#define LCD_CONT  0x0d
#define DAC_RESET 0x10
#define RDI_TEST  0x20
#define DAC_MUTE  0x40
#define SPDIF_SEL 0x80
