// io.c 290500 GA
//
// LCD and other IO calls, use with io_x.asm!
//
// $Id: io.c,v 1.11.2.12 2005/01/15 01:29:39 acher Exp $

#include "regezusb.h"
#pragma SAVE
#pragma NOOVERLAY

typedef unsigned char uchar;

#include "hw_variables.h"
#include "io.h"
extern void wait_0_1ms();
extern void small_wait(void);
uchar key;

/*-------------------------------------------------------------------*/
//! LCD output for I2C
/*void disp_out(uchar a,uchar b)
{
	if (a==0xc0)
		xilinx3=b;
	else
		xilinx2=b;
	small_wait();
}

*/
/*-------------------------------------------------------------------*/
//! Set cursor to (0,1)
void poscursor01(void)
{
	Cposcursor(0,1);
}

/*-------------------------------------------------------------------*/
//! prints integer with/without leading zeros
void printi(uchar s, uchar n)
{
	uchar x;
	x=s/100;
	if (x|| n>2) 
		Cputc('0'+x);
	s=s-x*100;
	x=s/10;
	if (x || n>1)
		Cputc('0'+x);
	s=s-x*10;
	Cputc('0'+s);
}
/*-------------------------------------------------------------------*/
#if 0
void printf_usb(void)
{
	if (OUT2BUF[3])
		poscursor(OUT2BUF[1],OUT2BUF[2]);
	OUT2BUF[63]=0;
	printf(OUT2BUF+4);    
}
#endif
/*-------------------------------------------------------------------*/
extern uchar get_xkeys(void);
//! key scan
#ifndef KEY12
void get_key()
{
	_asm;
	mov a,_key;
	jnz _gk1;

	mov dptr,#_OEB;
	mov a,#0x8f;
	movx @dptr,a;

	mov dptr,#_OUTB;
	mov a,#8;
	movx @dptr,a;

	mov dptr,#_OEB;
	mov a,#0x88;
	movx @dptr,a;
	
	mov dptr,#_PINSB;
	movx a,@dptr;
	anl a,#5;
	add a,acc;
	mov r0,a;

	mov dptr,#_OEB;
	mov a,#0x8f;
	movx @dptr,a;

	mov dptr,#_OUTB;
	mov a,#2;
	movx @dptr,a;

	mov dptr,#_OEB;
	mov a,#0x82;
	movx @dptr,a;

       	mov dptr,#_PINSB;
	movx a,@dptr;
	anl a,#5;
	orl a,r0;
	anl a,#0xf;
	mov _key,a;
_gk1:
	_endasm;

}
#else
void get_key()
{
	_asm;
	mov a,_key;
	jnz _gk1;
	lcall _get_xkeys;
	mov _key,a;
_gk1:
	_endasm;

}
#endif
/*-------------------------------------------------------------------*/
void clr_line1(void)
{
	poscursor01();
	Cprint_spaces(16);
	poscursor01();
}
/*-------------------------------------------------------------------*/
void clr_line0(void)
{
	poscursor00();
	Cprint_spaces(16);
	poscursor00();
}

/*-------------------------------------------------------------------*/
code char char_defs[]=
{
	0x00,0x00,0x00,0x10, 0x00,0x00,0x00,0,       // 0 <. >
	0x00,0x00,0x00,0x12, 0x00,0x00,0x00,0,       // 1 <..>
	0x18,0x18,0x18,0x1a, 0x18,0x18,0x18,0,       // 2 <|.>
	0x1b,0x1b,0x1b,0x1b, 0x1b,0x1b,0x1b,0,        // 3 <||>
	0x00,0x04,0x0e,0x1f, 0x00,0x00,0x00,0,        // 4 arrow up
	0x00,0x00,0x00,0x1f, 0x0e,0x04,0x00,0,        // 5 arrow down
	0x00,0x04,0x0c,0x1c, 0x0c,0x04,0x00,0,        // 6 arrow left
	0x00,0x08,0x0c,0x0e, 0x0c,0x08,0x00,0        // 6 arrow right
};

