;/**\file  io_x.asm
; I/O functions in pure assembler */
;/*

	.module io_x
	.include "regezusb.asm"	

	.globl _shift_left
	.globl _shift_right
	.globl _putc32
	.globl _putc_acc
	.globl _putc,_Cputc
	.globl _poscursor00
	.globl _poscursor_r01
	.globl _poscursor,_Cposcursor
	.globl _printh
	.globl _print_spaces
	.globl _Cprint_spaces
	.globl _get_xkeys
	.globl _Cbargraph
	.globl _bargraph
	.globl _define_char
	.globl _define_all_chars
	.globl _printf
	.globl _wait_key_release
	.globl _wait_key_release0
	.globl _printi_acc1
	.globl _printi_acc2
	.globl _show_lrarrows

	.globl _putc_PARM_1
	.globl _poscursor_PARM_1,_poscursor_PARM_2
	.globl _poscursor_PARM_1,_Cposcursor_PARM_2
	.globl _printh_PARM_1
	.globl _bargraph_PARM_1	
	.globl _bargraph_PARM_2
	.globl _bargraph_PARM_3	
	.globl _Cbargraph_PARM_2
	.globl _Cbargraph_PARM_3	
	.globl _printf_PARM_1	
	.globl _printf_PARM_2
	.globl _printf_PARM_3	


	.globl _define_char_PARM_1
	.globl _define_char_PARM_2
	.globl _wait_key_release_PARM_1
	.globl _dline,_screen
	.globl _print_spaces_PARM_1

; defs
  	ar0 = 0x00
        ar1 = 0x01
	ar2 = 0x02
        ar3 = 0x03
        ar4 = 0x04
        ar5 = 0x05
        ar6 = 0x06
        ar7 = 0x07
       
	xilinx2 = 0x8802
	xilinx3 = 0x8803


; Parameters

	.area DSEG    (DATA)

_putc_PARM_1:	
		.ds 1

_poscursor_PARM_1:	
_print_spaces_PARM_1:	
_define_char_PARM_1:
_printh_PARM_1:	
		.ds 1

_Cposcursor_PARM_2:	
_poscursor_PARM_2:	
_define_char_PARM_2:
_wait_key_release_PARM_1:
		.ds 1

_bargraph_PARM_1:
_printf_PARM_1:		
		.ds 1

_Cbargraph_PARM_2:
_bargraph_PARM_2:
_printf_PARM_2:		
		.ds 1

_Cbargraph_PARM_3:
_bargraph_PARM_3:
_printf_PARM_3:		
		.ds 1


; Variables
_dline:			.ds 1
_screen:		.ds 1

	.area XSEG    (XDATA)
; -------------------------------------------------------------------
	.area CSEG    (CODE)

; -------------------------------------------------------------------
_shift_left:
	mov r0,#8
_shiftl_1:
	mov a,#16+8
	mov  dptr,#xilinx2
	movx @dptr,a
	mov a,r0
	swap a
	mov r1,a
_shiftl_2:
	lcall _small_wait
	lcall _small_wait
	lcall _small_wait

	djnz r1,_shiftl_2
	djnz r0,_shiftl_1

	mov r0,#8
_shiftl_3:
	mov a,#16+8
	mov  dptr,#xilinx2
	movx @dptr,a
	mov a,#242
	add a,r0
	
	swap a
	mov r1,a
_shiftl_4:

	lcall _small_wait
	lcall _small_wait
	djnz r1,_shiftl_4
	djnz r0,_shiftl_3

	ret

_shift_right:
	mov r0,#16
_shiftr_1:
	mov a,#16+8+4
	mov  dptr,#xilinx2
	acall _dptr_out_wait
	djnz r0,_shiftr_1

	ret


; -------------------------------------------------------------------
_dptr_out_wait:
	movx @dptr,a
	ljmp _small_wait	
_putc32:
	mov _putc_PARM_1,#32
	sjmp _putc
; -------------------------------------------------------------------
;*//** IO primitive, outputs one char to Xilinx LCD-IO
;*/  void putc(char c) {} /*
_Cputc:
	mov _putc_PARM_1,dpl
_putc:
	mov a,_putc_PARM_1
_putc_acc:
 .if 0	
	jnb acc.7, _no_convert
	clr acc.7
	mov dptr,#convert_table
	add a,dpl
	mov dpl,a
	clr a
	addc a,dph
	mov dph,a
	movx a,@dptr
 .endif
_no_convert:
	mov dptr,#xilinx3
	acall _dptr_out_wait

	inc _dline
	mov  dptr,#xilinx2
	mov a,_dline
	cjne a,#16,not16
	mov a,#128+64
	add a,_screen
	sjmp _dptr_out_wait
not16:
	cjne a,#32,nret
	mov a,#128
	add a,_screen
	mov _dline,#0
	sjmp _dptr_out_wait
nret:
	ret
 .if 0
convert_table:
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .endif
; -------------------------------------------------------------------
;*//** Prints string (0 terminated, 16chars max)
;*/ void printf(char* string) {} /*
_printf:
	mov dpl,_printf_PARM_1;
	mov dph,_printf_PARM_2;

	mov r0,#16
_pf1:
	movx a,@dptr;
	jz _pf2;
	inc DPS

	acall _putc_acc
	inc DPS
	inc dptr

	djnz r0,_pf1
_pf2:
	ret
; -------------------------------------------------------------------

; -------------------------------------------------------------------
_printi_acc1:
;	mov _printi_PARM_1,a
	mov dpl,a
	mov _printi_PARM_2,#1
	ljmp _printi
; -------------------------------------------------------------------
_printi_acc2:
;	mov _printi_PARM_1,a
	mov dpl,a
	mov _printi_PARM_2,#2
	ljmp _printi
; -------------------------------------------------------------------
_Cposcursor:
	mov _poscursor_PARM_1,dpl
	sjmp _poscursor

_poscursor00:
	mov r0,#0
	mov r1,#0
; -------------------------------------------------------------------
_poscursor_r01:
	mov _poscursor_PARM_1,r0
	mov _poscursor_PARM_2,r1

; -------------------------------------------------------------------
;*//** Cursor positioning
;*/ void poscursor(char x, char y)[changes dptr,a]{} /*
_poscursor:
	push ar1
	mov a,_poscursor_PARM_1
	mov r1,_poscursor_PARM_2 	; r1:y 

	mov dptr,#xilinx2
	cjne r1,#0,y_not_zero

	mov _dline,a
	sjmp posx

y_not_zero:
	setb acc.4
	mov _dline,a
	add a,#64-16
posx:
	pop ar1
	setb acc.7
	add a,_screen
	acall _dptr_out_wait
	ret
; -------------------------------------------------------------------
;*//** Prints n spaces 
;*/ void print_spaces(uchar i) {} /*
_Cprint_spaces:
	mov _print_spaces_PARM_1,dpl
_print_spaces:
	mov r0,_print_spaces_PARM_1
_ps1:
	push ar0
	acall _putc32
	pop ar0
	djnz r0,_ps1	
	ret
; -------------------------------------------------------------------
;*//**prints one-digit hex (in accu) (helper sub)
;*/ void printhh(accu) {} /*	
printhh:
	anl a,#0xf
	mov r0,a
	clr c
	subb a,#10
	jnc greater9
	add a,#48+10
	sjmp printhhx
greater9:
	add a,#55+10
printhhx:
	ljmp _putc_acc
; -------------------------------------------------------------------
;*//** Hex byte output
;*/ void printh(uchar s){} /*
_printh:
	push ar0
	mov a,_printh_PARM_1
	swap a
	acall printhh
	mov a,_printh_PARM_1
	acall printhh
	pop ar0
	ret
; -------------------------------------------------------------------
;*//** waits for key release (no timeout)
;*/ void wait_key_release0(void){} /*
_wait_key_release0:
	mov _wait_key_release_PARM_1,#0
	sjmp _wait_key_release	
; -------------------------------------------------------------------
;*//** wait for key release with timeout, clears key, key in xkey
;*/ uchar wait_key_release(uchar maxw) {} /*
_wait_key_release:
	mov r0,#0
_wkr1:
	push ar0
	mov _key,#0
	lcall _wait_1000
	pop ar0

	mov a,_key
	jz _wkr2
	
	mov a,_wait_key_release_PARM_1
	jz _wkr1

	inc r0
	clr c
	subb a,r0
	jnc _wkr1
_wkr2:
	mov dpl,r0
	mov _xkey,_key
	mov _key,#0
	ret
; -------------------------------------------------------------------
;*//** Set OEB to accu/0xf and read PINSB
;*/ accu SET_OEB_F(void) {}
;accu SET_OEB(accu) {} /*
SET_OEB_F:
	mov a,#0xf
SET_OEB_GET_PINSB:
	mov dptr,#OEB
	anl a,#0x0f
	orl a,#0x80
	movx @dptr,a
	mov dptr,#PINSB
	movx a,@dptr
	ret

;*//** Set OUTB to accu
;*/ void SET_OUTB(accu)[saves r0,accu]{} /*
SET_OUTB:
	push ar0
	push acc
	mov dptr,#OUTB
	movx a,@dptr
	anl a,#0xf0
	pop ar0
	orl a,r0
	pop ar0
	movx @dptr,a
	ret
;*//** Sets OUTB to mask in accu
;*/ void SET_OEB_OUTB(){} /*
SET_OEB_OUTB:
	push acc
	acall SET_OEB_F
	pop acc
	acall SET_OUTB
	ret


;*//** Key scan sequence for 1 level
;*/ void SET_KEY_SET(accu) {} /*
SET_KEY_SET:
	clr IE.7
	push acc
_sks1:
	acall SET_OEB_OUTB
	pop acc
	acall SET_OEB_GET_PINSB
	setb IE.7
	ret
;*//**  Key scan sequence for 0 level
;*/ void SET_KEY_INV(accu) {} /*
SET_KEY_INV:
	clr IE.7
	push acc
	xrl a,#0xf
	sjmp _sks1
; -------------------------------------------------------------------
.if 0
	; my own
	KX0 = 2
	KX1 = 9
	KX2 = 7
	KX3 = 8
	KX4 = 12
	KX5 = 5
	KX6 = 10
	KX7 = 1
	KX8 = 11
	KX9 = 4
	KX10 = 3
	KX11 = 6
.else
.if 0
	; first Terratec
	KX0 = 3
	KX1 = 2
	KX2 = 1
	KX3 = 7
	KX4 = 5
	KX5 = 11
	KX6 = 6
	KX7 = 8
	KX8 = 4
	KX9 = 9
	KX10 = 10
	KX11 = 12
.else
	; second Terratec
	KX0 = 6
	KX1 = 8
	KX2 = 7
	KX3 = 1
	KX4 = 9
	KX5 = 4
	KX6 = 3
	KX7 = 2
	KX8 = 11
	KX9 = 5
	KX10 = 12
	KX11 = 10 
.endif
.endif
;*//** Key matrix scan (12keys)
;*/ accu get_xkeys(void) {} /*

_get_xkeys:
	mov a,#0x1
	acall SET_KEY_SET

	jnb acc.3,_gxs1
	mov a,#KX0
	ret
_gxs1:
	jnb acc.2,_gxs2
	mov a,#KX1
	ret	
_gxs2:
	jnb acc.1,_gxs3
	mov a,#KX2
	ret
_gxs3:
	mov a,#0x1
	acall SET_KEY_INV

	jb acc.1,_gxs4
	mov a,#KX3
	ret
_gxs4:
	jb acc.2,_gxs5
	mov a,#KX4
	ret	
_gxs5:
	jb acc.3,_gxs6
	mov a,#KX5
	ret

_gxs6:
	mov a,#2
	acall SET_KEY_SET

	jnb acc.2,_gxs7
	mov a,#KX6
	ret
_gxs7:
	jnb acc.3,_gxs8
	mov a,#KX7
	ret	
_gxs8:
	mov a,#2
	acall SET_KEY_INV

	jb acc.2,_gxs9
	mov a,#KX8
	ret
_gxs9:
	jb acc.3,_gxs10
	mov a,#KX9
	ret

_gxs10:
	mov a,#4
	acall SET_KEY_SET

	jnb acc.3,_gxs11
	mov a,#KX10
	ret
_gxs11:

	mov a,#4
	acall SET_KEY_INV

	jb acc.3,_gxs12
	mov a,#KX11
	ret
_gxs12:
	clr a
	ret
; -------------------------------------------------------------------
;*//** Bargraph display
;*/ void bargraph(uchar bars, uchar px, uchar py) {} /*
_Cbargraph:
	mov _bargraph_PARM_1,dpl
	
_bargraph:

	mov r1,#1

	mov a,_bargraph_PARM_3
	jb acc.1,_bg1
	mov r1,#3
_bg1:
	anl a,#1

	mov _poscursor_PARM_2,a
	mov _poscursor_PARM_1,_bargraph_PARM_2
	lcall _poscursor

	mov a,_bargraph_PARM_1
	rr a
	anl a,#63
	jz _bg4a
	mov r0,a
	
_bg3:
	mov a,r1
	lcall _putc_acc
_bg4:
	djnz r0,_bg3		

_bg4a:
	mov a,_bargraph_PARM_1
	jnb acc.0,_bg5
	dec r1
	mov a,r1
	lcall _putc_acc
_bg5:
	ret
; -------------------------------------------------------------------
_define_all_chars:
	clr a
	mov _define_char_PARM_1,a
	mov r2,#8
_bg0:
	acall _define_char
	inc _define_char_PARM_1
	djnz r2,_bg0
	ret
	
; -------------------------------------------------------------------
;*//** LCD character definition
;*/void define_char(uchar num/type) {} /*
_define_char:
	mov a,_define_char_PARM_1
	anl a,#15
	rl a
	rl a
	rl a		; *8
	add a,#64
	mov dptr,#xilinx2
	movx @dptr,a
	lcall _dptr_out_wait
	
	mov a,_define_char_PARM_1
	mov b,#8
	mul ab
	mov r1,a

	mov r0,#8
_df1:
	mov a,r1
	mov dptr,#_char_defs	
	movc a,@a+dptr
	mov dptr,#xilinx3
	inc r1
	lcall _dptr_out_wait
	djnz r0,_df1

	ret
;*/	
; -------------------------------------------------------------------
_show_lrarrows:
	lcall _poscursor01
	mov a,#6
	lcall _putc_acc
	mov r0,#15
	mov r1,#1
	lcall _poscursor_r01
	mov a,#7
	ljmp _putc_acc
