; DAB-USB MAIN

	.module main
	
	.include "regezusb.asm"

	.globl _write_nvram
	.globl _nvram_bank,_nvram_addr,_nvram_val
	.globl _read_nvram
	.globl _clear_lcd


RL		= 7
ar0		= 0
ar1		= 1
ar2		= 2
ar3		= 3
ar4		= 4
ar5		= 5
ar6		= 6
ar7		= 7

xilinx2		= 0x8802

	.area STARTUP (ABS)
	.org 0
; /** 8051 standard vector table
;*/ vector_table def8051 () {}	/*
	ajmp	startup
	.ds	1
	ljmp	xreti ;; _int0_isr
	.ds	5
	ljmp	xreti ;;_timer0_isr
	.ds	5
	ljmp	xreti ;; _int1_isr
	.ds	5
	ljmp	xreti ;;_timer1_isr
	.ds	5
	ljmp	xreti ;;_ser0_isr
	.ds	5
	ljmp	xreti ;;_timer2_isr
	.ds	5
	ljmp	_resume_isr
	.ds	5
	ljmp	 xreti ;;_ser1_isr
	.ds	5
	ljmp	_usb_isr
	.ds	5
	ljmp	 xreti ;_i2c_isr
	.ds	5
	ljmp	xreti ;_int4_isr
	.ds	5
	ljmp	_int5_isr
	.ds	5
	ljmp	_int6_isr
;---------------------------------------------------------------------
;*//** Wait for I2C Ack, preserves dptr
;*/ void wait_done(void) [changes r0, saves dptr] {} /*
	.globl  _wait_done
_wait_done:
	push dph
	push dpl
	mov r0,#5

wait_done_loop:
	mov dptr,#I2CS
	movx a,@dptr
	jb acc.0,wx
	acall _wait_0_1ms
	djnz r0,wait_done_loop
wx:
	pop dpl
	pop dph
	ret
;---------------------------------------------------------------------
;*//** waits for 300 cycles
;*/ void small_wait(void) [changes r0] {} /*
	.globl _small_wait
_small_wait:
	push ar0
	mov r0,#250
small_wait_loop:
	djnz r0,small_wait_loop
	pop ar0
	ret
;---------------------------------------------------------------------
;*//** I2C output for address and one data byte
;*/ void i2c_out2(uchar b, uchar c){} /*
	.globl _i2c_out2

i2c_out2_without_stop:
	mov dptr,#I2CS
        mov a,#0x80
        movx @dptr,a
        inc dpl
        mov a,#0x9a
        movx @dptr,a
        acall _wait_done

        mov a,_i2c_out2_PARM_1
        movx @dptr,a
        acall _wait_done

        mov a,_i2c_out2_PARM_2
        movx @dptr,a
        ljmp _wait_done

_i2c_out2:
	acall i2c_out2_without_stop
send_stop:
        dec dpl
        mov a,#0x40
	movx @dptr,a
	ret
; -------------------------------------------------------------------
;*//** I2C output of address and two data bytes
;*/ void i2c_out3(uchar b, uchar c,uchar d){} /*
	.globl _i2c_out3
	.globl _i2c_out2_PARM_1,_i2c_out3_PARM_1
	.globl _i2c_out3_PARM_2,_i2c_out2_PARM_2
	.globl _i2c_out3_PARM_3

_i2c_out3:
;	mov _printh_PARM_1,_i2c_out3_PARM_2
;	lcall _printh
	lcall i2c_out2_without_stop

	mov a,_i2c_out3_PARM_3
        movx @dptr,a
	lcall _wait_done
	ljmp send_stop
	ret
; -------------------------------------------------------------------
;*/ /** USB vector table
;*/ vector_table usb_isr() {} /*
	.org 0x100
_usb_isr:
	ljmp    _usb_sudav_isr
	.ds	1
	ljmp	_usb_sof_isr
	.ds	1
	ljmp	_usb_sutok_isr
	.ds	1
	ljmp	_usb_suspend_isr
	.ds	1
	ljmp    _usb_usbreset_isr
	.ds	1
	reti
	.ds	3
	reti     ;_usb_ep0in_isr
	.ds	3
	ljmp	_usb_ep0out_isr
	.ds	1
	ljmp	xreti ;;_usb_ep1in_isr
	.ds	1
	ljmp	xreti ;;_usb_ep1out_isr
	.ds	1
	ljmp	_usb_ep2in_isr
	.ds	1
	ljmp	_usb_ep2out_isr
	.ds	1
	ljmp	xreti;_usb_ep3in_isr
	.ds	1
	ljmp	xreti;_usb_ep3out_isr
	.ds	1
	ljmp	xreti;_usb_ep4in_isr
	.ds	1
	ljmp	xreti;_usb_ep4out_isr
	.ds	1
	ljmp	xreti;_usb_ep5in_isr
	.ds	1
	ljmp	xreti;_usb_ep5out_isr
	.ds	1
	ljmp	xreti;_usb_ep6in_isr
	.ds	1
	ljmp	xreti;_usb_ep6out_isr
	.ds	1
	ljmp	xreti;_usb_ep7in_isr
	.ds	1
	ljmp	xreti;_usb_ep7out_isr
;*//** Startup code. Init stack
;*/ void startup_code(){} /*

startup:
	; //allow for all 4 banks to be used (otherwise use eg. 7)
	;mov	sp,#31
	;; set stack to indirect data area
	mov	sp,#0x7f
;	lcall	__sdcc_external_startup
	mov	a,dpl
	jz	__sdcc_init_data
	ljmp	__sdcc_program_startup
__sdcc_init_data:

;//	 .area   CSEG (CODE)
__sdcc_program_startup:
	lcall	_ezusbmain
	ajmp	.

xreti:
	reti


;---------------------------------------------------------------------
_write_nvram:
	push dph
	push dpl
	mov dptr,#I2CS;
	mov a,#0x80;
	movx @dptr,a;
	inc dptr;
	mov a,#0xa2;
	movx @dptr,a;
	acall _wait_done;

	mov dptr,#I2DAT;

	mov a,_nvram_bank
	movx @dptr,a;
	acall _wait_done;

	mov a,_nvram_addr
	movx @dptr,a;
	acall _wait_done;

	mov a,_nvram_val
	movx @dptr,a;
	acall _wait_done;

	mov dptr,#I2CS;
	mov a,#0x40;
	movx @dptr,a;

	mov r0,#254;
nv_wr_l:
	acall _wait_0_1ms;
	djnz r0,nv_wr_l;
	pop dpl
	pop dph
	ret
;---------------------------------------------------------------------
_read_nvram:
	mov a,_nvram_bank
	mov r2,a;

	mov a,_nvram_addr
	mov r3,a;

	lcall _i2c_set_addr_read

	mov dptr,#I2DAT
	movx a,@dptr
	push acc

	lcall _i2c_stop_read
	pop acc
	mov dpl,a;
	ret
;------------------------------------------------------------
; ASM-Binding! Addr-H in r2, L in r3
_i2c_set_addr_read:
	mov dptr,#I2CS; 
	mov a,#0x80; // Start
	movx @dptr,a;

	inc dptr;        ; #_I2DAT;
	mov a,#0xa2      ;  addr
	movx @dptr,a;
	lcall _wait_done;

	mov a,r2;
	movx @dptr,a;
	lcall _wait_done;

	mov a,r3;
	movx @dptr,a;
	lcall _wait_done;

	mov dptr,#I2CS;
	mov a,#0x80;
	movx @dptr,a;

	inc dptr        ;    #_I2DAT;
	mov a,#0xa3;
	movx @dptr,a;
	lcall _wait_done;

	movx a,@dptr; //dummy
	lcall _wait_done
	ret
;------------------------------------------------------------
_i2c_stop_read:
	mov dptr,#I2CS;
	mov a,#0x60;
	movx @dptr,a;

	inc dptr;        #_I2DAT;
	movx a,@dptr;
	ljmp _wait_done; 


	; .area CODE2 (ABS)	
	 ;.org 0x1800
;------------------------------------------------------------
; Clears LCD
_clear_lcd:
	mov dptr,#xilinx2
	mov a,#1
	movx @dptr,a
	mov r0,#255
clear_lcd_loop:
	acall _wait_0_1ms	
	acall _wait_0_1ms	
	djnz r0,clear_lcd_loop
	ret

;------------------------------------------------------------
;*//** Interrupt 6, RDI streaming 
; */ interrupt int6_isr(void){}/*
_int6_isr:
	push PSW
	push DPS
	push DPL
	push DPH
	push DPL1
	push DPH1
	push acc
	
	;sjmp zzzz		
	mov dptr,#OUTB
	movx a,@dptr
	orl a,#0x80		; select rdi
	movx  @dptr,a

	mov dptr,#IN9DATA	; ep9 RDI
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a

	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a

	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a

	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a

	mov dptr,#OUTB
	movx a,@dptr
	anl a,#0x7f
	movx @dptr,a
zzzz:	
	mov dptr,#PINSB
	movx a,@dptr
	jnb acc.4,int_ende

	mov dptr,#IN8DATA	; ep8 I2S#
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a

	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a

	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a

	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a
	movx @dptr,a

int_ende:
	mov a,EICON		; Clr irq
	clr acc.3
	mov EICON,a
	
	pop acc
	pop DPH1
	pop DPL1
	pop DPH
	pop DPL
	pop DPS
	pop PSW
	reti
;; -----------------------------------------------------------------------

;---------------------------------------------------------------------
;*//** Waits for 0.1s
;*/ void wait_1000(void)[changes r2,r3]{}/*
	.globl _wait_1000
_wait_1000:
	mov r2,#10
wait_1000_1:
	mov r3,#100
wait_1000_2:
	acall _wait_0_1ms
	djnz ar3,wait_1000_2
	djnz ar2,wait_1000_1
	ret
;*/


	.area DSEG    (DATA)

_i2c_out2_PARM_1:
_i2c_out3_PARM_1:	.ds 1

_i2c_out3_PARM_2:
_i2c_out2_PARM_2:	.ds 1

_i2c_out3_PARM_3:	.ds 1