; DAB-USB STANDALONE MAIN

	.module main_a
	
	.globl _small_wait
	.globl _wait_3000
	.globl _wait_1000
	.globl _wait_done
	.globl _clear_lcd
	.globl _wait_0_1ms
	.globl _write_nvram
	.globl _nvram_bank,_nvram_addr,_nvram_val
	.globl _read_nvram
	.globl _i2c_out2
	.globl _i2c_out3
	.globl _Ci2c_out2
	.globl _Ci2c_out3
	.globl _wait_1s

	.globl _i2c_out2_PARM_1,_i2c_out3_PARM_1

	.globl _i2c_out3_PARM_2,_i2c_out2_PARM_2
	.globl _i2c_out3_PARM_3

	.globl _Ci2c_out2_PARM_2

	.globl _Ci2c_out3_PARM_2
	.globl _Ci2c_out3_PARM_3


	.include "regezusb.asm"
	

RL		= 7
ar0		= 0
ar1		= 1
ar2		= 2
ar3		= 3
ar4		= 4
ar5		= 5
ar6		= 6
ar7		= 7

xilinx2		= 0x8802

; Parameters

	.area DSEG    (DATA)

_i2c_out2_PARM_1:
_i2c_out3_PARM_1:	.ds 1

_Ci2c_out3_PARM_2:
_Ci2c_out2_PARM_2:
_i2c_out3_PARM_2:
_i2c_out2_PARM_2:	.ds 1

_Ci2c_out3_PARM_3:
_i2c_out3_PARM_3:	.ds 1
;---------------------------------------------------------------------
	.area STARTUP (ABS)
	.org 0
	ajmp	startup
	.ds	1
	ljmp	xreti ;; _int0_isr
	.org   0xb
	ljmp	_timer0_isr ;;_timer0_isr
;---------------------------------------------------------------------
xreti:
	reti
;---------------------------------------------------------------------

_small_wait:
	push ar0
	mov r0,#150
small_wait_loop:
	djnz r0,small_wait_loop
	pop ar0
	ret
;---------------------------------------------------------------------
_wait_3000:
	mov r2,#10
wait_3000_1:
	mov r3,#200
wait_3000_2:
	push ar2
	push ar3
	lcall _wait_0_1ms
	pop ar3
	pop ar2
	djnz ar3,wait_3000_2
	djnz ar2,wait_3000_1
	ret
;---------------------------------------------------------------------
	
startup:
	;; allow for all 4 banks to be used (otherwise use eg. 7)
	mov	sp,#0x7f
	jz	__sdcc_init_data
	ljmp	__sdcc_program_startup

	
__sdcc_init_data:

	
__sdcc_program_startup:
	lcall	_ezusbmain
	ajmp	.
;---------------------------------------------------------------------

;---------------------------------------------------------------------
	.area STARTUP (ABS)
	.org 0x40
;	ljmp	_usb_isr	

;---------------------------------------------------------------------
; Wait for I2C Ack, preserves dptr
_wait_done:
	push dph
	push dpl
	mov r0,#5

wait_done_loop:
	mov dptr,#I2CS
	movx a,@dptr
	jb acc.0,wx
	acall _wait_0_1ms
	djnz r0,wait_done_loop
wx:
	pop dpl
	pop dph
	ret
;---------------------------------------------------------------------
_wait_1000:
	mov r2,#10
wait_1000_1:
	mov r3,#100
wait_1000_2:
	acall _wait_0_1ms
	djnz ar3,wait_1000_2
	djnz ar2,wait_1000_1
	ret
;---------------------------------------------------------------------
; Clears LCD
_clear_lcd:
	mov dptr,#xilinx2
	mov a,#1
	movx @dptr,a
	mov r0,#255
clear_lcd_loop:
	acall _wait_0_1ms	
	acall _wait_0_1ms	
	djnz r0,clear_lcd_loop
	ret
;---------------------------------------------------------------------
_wait_0_1ms:
	mov     dptr,#(0xffff - 60)    ; long pulse for operating
_wx_loop:
        inc     dptr            ; 3 cycles
        mov     a,dpl           ; 2 cycles
        orl     a,dph           ; 2 cycles
        jnz     _wx_loop            ; 3 cycles
	ret
;---------------------------------------------------------------------
_write_nvram:
	push dph
	push dpl
	mov dptr,#I2CS;
	mov a,#0x80;
	movx @dptr,a;
	inc dptr;
	mov a,#0xa2;
	movx @dptr,a;
	acall _wait_done;

	mov dptr,#I2DAT;

	mov a,_nvram_bank
	movx @dptr,a;
	acall _wait_done;

	mov a,_nvram_addr
	movx @dptr,a;
	acall _wait_done;

	mov a,_nvram_val
	movx @dptr,a;
	acall _wait_done;

	mov dptr,#I2CS;
	mov a,#0x40;
	movx @dptr,a;

	mov r0,#254;
nv_wr_l:
	acall _wait_0_1ms;
	djnz r0,nv_wr_l;
	pop dpl
	pop dph
	ret
;---------------------------------------------------------------------
_read_nvram:
	mov r2,_nvram_bank

	mov r3,_nvram_addr

	lcall _i2c_set_addr_read

	mov dptr,#I2DAT
	movx a,@dptr
	push acc

	lcall _i2c_stop_read
	pop acc
	mov dpl,a;
	ret
;---------------------------------------------------------------------
; void i2c_out2(uchar b, uchar c)
i2c_out2_without_stop:
	mov dptr,#I2CS
        mov a,#0x80
        movx @dptr,a
        inc dpl
        mov a,#0x9a
        movx @dptr,a
        acall _wait_done

        mov a,_i2c_out2_PARM_1
        movx @dptr,a
        acall _wait_done

        mov a,_i2c_out2_PARM_2
        movx @dptr,a
        ljmp _wait_done

_Ci2c_out2:
	mov _i2c_out2_PARM_1,dpl
_i2c_out2:
	acall i2c_out2_without_stop
send_stop:
        dec dpl
        mov a,#0x40
	movx @dptr,a
	ret
; -------------------------------------------------------------------
; void i2c_out3(uchar b, uchar c,uchar d)
_Ci2c_out3:
	mov _i2c_out3_PARM_1,dpl
_i2c_out3:
	lcall i2c_out2_without_stop

	mov a,_i2c_out3_PARM_3
        movx @dptr,a
	lcall _wait_done
	ljmp send_stop;
;---------------------------------------------------------------------
_wait_1s:
	acall _wait_3000
	acall _wait_3000
	acall _wait_3000
	ret
;---------------------------------------------------------------------
	.org 0x110

.if 0
_usb_isr:
	ljmp    0; _usb_sudav_isr
	.ds	1
	ljmp	0; _usb_sof_isr
	.ds	1
	ljmp	0; _usb_sutok_isr
	.ds	1
	ljmp	0; _usb_suspend_isr
	.ds	1
	ljmp    0; _usb_usbreset_isr
	.ds	1
	reti
	.ds	3
	reti     ;_usb_ep0in_isr
	.ds	3
	ljmp	0 ;; _usb_ep0out_isr
	.ds	1
	ljmp	0 ;;_usb_ep1in_isr
	.ds	1
	ljmp	0 ;;_usb_ep1out_isr
	.ds	1
	ljmp	0 ;;_usb_ep2in_isr
	.ds	1
	ljmp	0;;ice_epout_isr
	.ds	1
	ljmp	0;_usb_ep3in_isr
	.ds	1
	ljmp	0;_usb_ep3out_isr
	.ds	1

	ljmp	0;_usb_ep4in_isr
	.ds	1
	ljmp	0;_usb_ep4out_isr
	.ds	1
	ljmp	0;_usb_ep5in_isr
	.ds	1
	ljmp	0;_usb_ep5out_isr
	.ds	1
	ljmp	0;_usb_ep6in_isr
	.ds	1
	ljmp	0;_usb_ep6out_isr
	.ds	1
	ljmp	0;_usb_ep7in_isr
	.ds	1
	ljmp	0;_usb_ep7out_isr
.endif

	.area DSEG    (DATA)

_nvram_bank:
	.ds 1
_nvram_addr:
	.ds 1
_nvram_val:
	.ds 1