; storage_ax.asm
; NVRAM and storage management
; $Id: storage_ax.asm,v 1.1.2.8 2005/01/15 01:29:40 acher Exp $

	.module storage_ax
	.include "regezusb.asm"	
	.include "defines_t.asm"

	.globl _copy_16bytes,_copybytes_loop
	.globl _calc_name_addr_dptr
	.globl _Ccurrent_2_scratch
	.globl _current_2_scratch
	.globl _Cscratch_2_current
	.globl _scratch_2_current
	.globl _scratch_2_NVC
	.globl _Cscratch_2_NVS
	.globl _scratch_2_NVS
	.globl _CNVC_2_scratch
	.globl _CNVS_2_scratch
	.globl _NVS_2_scratch
	.globl _find_banked
	.globl _Ccurrent_2_NVC
	.globl _current_2_NVC
	.globl _get_sid
	.globl _update_current_data

	.globl _Cscratch_2_NVS_PARM_2
	.globl _scratch_2_NVS_PARM_2
	.globl _CNVS_2_scratch_PARM_2
	.globl _NVS_2_scratch_PARM_2

	.globl _current_2_scratch_PARM_1
	.globl _scratch_2_current_PARM_1
	.globl _scratch_2_NVC_PARM_1
	.globl _scratch_2_NVS_PARM_1
	.globl _NVC_2_scratch_PARM_1
	.globl _NVS_2_scratch_PARM_1

	.area DSEG    (DATA)

_Cscratch_2_NVS_PARM_2:
_scratch_2_NVS_PARM_2:
_NVS_2_scratch_PARM_2:
_CNVS_2_scratch_PARM_2:
program_storage:
			.ds 1

_current_2_scratch_PARM_1:
_Ccurrent_2_scratch_PARM_1:

_scratch_2_current_PARM_1:
_Cscratch_2_current_PARM_1:

_scratch_2_NVC_PARM_1:
_scratch_2_NVS_PARM_1:
_NVC_2_scratch_PARM_1:
_NVS_2_scratch_PARM_1:
scratch_index:
			.ds 1

	.area CSEG    (CODE)
; -------------------------------------------------------------------
; dptr: destination, r1/r0: source
_copy_16bytes:
	mov DPH1,r1
	mov DPL1,r0
	mov r0,#16
_copybytes_loop:
	clr IE.7
_copybytes_loopx:
	inc DPS
	movx a,@dptr
	inc dptr
	inc DPS
	movx @dptr,a
	inc dptr
	djnz r0,_copybytes_loopx
	setb IE.7
	ret
; -------------------------------------------------------------------
_calc_scratch:
	mov dptr,#_scratch0
	mov a,scratch_index
	anl a,#3
	swap a	; *16
	add a,acc; *32
	add a,dpl
	mov dpl,a
	ret
; -------------------------------------------------------------------
_calc_nvram_addr:
	mov a,program_storage
	dec a
	anl a,#16+8
	rr a	; /2 
	rr a	; /4
	rr a	; /8
	add a,#NV_BANK1
	mov _nvram_bank,a

	mov a,program_storage
	dec a
	anl a,#7
	swap a	; *16
	rl a	; *32
	mov _nvram_addr,a
	ret
; -------------------------------------------------------------------
; return in r0/r1 H/L
_calc_name_addr_cur:
	mov a,_subch
_calc_name_addr:

	swap a
	anl a,#240
	mov r1,#_names>>8
	mov r0,a
	ret
; -------------------------------------------------------------------
; return in dptr
_calc_name_addr_dptr_cur:
	mov a,_subch
_calc_name_addr_dptr:

	swap a
	anl a,#240
	mov dph,#_names>>8
	mov dpl,a
	ret
; -------------------------------------------------------------------
;  subch, channel|band , storage, bank, name[16] -> scratch
; current_2_scratch(uchar _current_2_scratch_PARM_1)
_Ccurrent_2_scratch:
	mov _Ccurrent_2_scratch_PARM_1,dpl
_current_2_scratch:
	lcall _update_current_data
	anl _band,#1
	acall _calc_scratch
	mov r0,#_subch
	mov r1,#16
_c2s_l:
	mov a,@r0
	movx @dptr,a
	inc dptr
	inc r0
	djnz r1,_c2s_l
	
	acall _calc_name_addr_cur
	ljmp _copy_16bytes
; -------------------------------------------------------------------
;  subch, channel, band, storage, bank, name[16] -> IRAM
;_scratch_2_current (uchar _scratch_2_current_PARM_1)
_Cscratch_2_current:
	mov _Cscratch_2_current_PARM_1,dpl
_scratch_2_current:
	acall _calc_scratch

	mov r0,#_subch
	mov r1,#7
_s2c_l:
	movx a,@dptr
	mov @r0,a
	inc dptr
	inc r0
	djnz r1,_s2c_l

	mov a,dpl
	add a,#9
	mov dpl,a

	mov r1,dph
	mov r0,dpl
	mov dptr,#_current_name
	ljmp _copy_16bytes
; -------------------------------------------------------------------
; _copy_to_NVRAM r0: count, dptr: 
_copy_to_NVRAM:
	movx a,@dptr
	inc dptr
	mov _nvram_val,a
	push ar0
	lcall _write_nvram
	pop ar0
	inc _nvram_addr
	djnz r0,_copy_to_NVRAM
	ret
; -------------------------------------------------------------------
; save scratch values to "current" NVRAM
; scratch_2_NVC(uchar scratch_2_NVC_PARM1)

_scratch_2_NVC:

	lcall _calc_scratch

	mov _nvram_bank,#NV_BANK0
	mov _nvram_addr,#NV_SUBCH
	mov r0,#7
	sjmp _copy_to_NVRAM
; -------------------------------------------------------------------
; save scratch values to storage NVRAM
; scratch_2_NVS(uchar _scratch_2_NVS_PARM1, uchar scratch_2_NVS_PARM2)
_Cscratch_2_NVS:
	mov _scratch_2_NVS_PARM_1,dpl
_scratch_2_NVS:
	lcall _calc_scratch
	lcall _calc_nvram_addr
	
	mov r0,#32
	sjmp _copy_to_NVRAM
	
; -------------------------------------------------------------------
;_copy_from_NVRAM r0: count dptr dest
_copy_from_NVRAM:
	push ar0
	push dpl
	push dph
	lcall _read_nvram
	mov a,dpl
	pop dph
	pop dpl
	pop ar0

	movx @dptr,a
	inc dptr
	inc _nvram_addr
	djnz r0,_copy_from_NVRAM
	ret
; -------------------------------------------------------------------
; load NVRAM current values to scratch
; NVC_2_scratch(uchar NVC_2_current_PARM1)
_CNVC_2_scratch:
	mov _NVC_2_scratch_PARM_1,dpl
_NVC_2_scratch:
	mov _nvram_bank,#NV_BANK0
	mov _nvram_addr,#NV_SUBCH
	lcall _calc_scratch
	mov r0,#7
	sjmp _copy_from_NVRAM
	
; -------------------------------------------------------------------
; load NVRAM storage values to scratch
; NVS_2_scratch(uchar  NVS_2_scratch_PARM1, uchar NVS_2_scratch_PARM2);
_CNVS_2_scratch:
	mov _NVS_2_scratch_PARM_1,dpl
_NVS_2_scratch:

	lcall _calc_scratch
	lcall _calc_nvram_addr

	mov r0,#32
	sjmp _copy_from_NVRAM
; -------------------------------------------------------------------
; compare current with NVRAM values
_find_banked:
	mov r0,#24
	mov r1,#1	
fb_loop:
	mov program_storage,r1
	lcall _calc_nvram_addr

	push ar0
	push ar1

	lcall _read_nvram
	push dpl	; subch

        inc     _nvram_addr
        lcall   _read_nvram
	push dpl 	; band

        inc     _nvram_addr
        lcall   _read_nvram
	mov r5,dpl 	; channel
	
	pop ar6		; r6:= band
	pop ar7		; r7:= subch

	pop ar1
	pop ar0
	
	mov a,r5
        cjne a,_channel,fb_not_eq

        mov a,r6
        cjne a,_band,fb_not_eq

        mov a,r7
        cjne a,_subch,fb_not_eq

        mov     dpl,r1
	ret

fb_not_eq:
	inc r1
	djnz r0,fb_loop
        mov dpl,#0xFF
        ret
; -------------------------------------------------------------------
_Ccurrent_2_NVC:
_current_2_NVC:
	mov scratch_index,#0
	lcall _current_2_scratch
	ljmp _scratch_2_NVC
; -------------------------------------------------------------------
; returns SID H in r0, L in r1/a
; parameter in a

_get_sid:
	rl a		; *2
	add a,#_sids
	mov dph,#_sids>>8
	mov dpl,a
	ljmp _get_sid_dptr
; -------------------------------------------------------------------
_update_current_data:
	mov a,_subch
	acall _get_sid
	mov _sidh,r0
	mov _sidl,r1

	mov dptr,#_current_name		; dest
	acall _calc_name_addr_cur	; source in r0/r1
	ljmp _copy_16bytes	
; -------------------------------------------------------------------
