// USB defines

// Audio class specific request codes (bRequest SETUPDAT[1])
#define SET_CUR 0x01
#define GET_CUR 0x81

#define SET_MIN 0x02
#define GET_MIN 0x82

#define SET_MAX 0x03
#define GET_MAX 0x83

#define SET_RES 0x04
#define GET_RES 0x84

#define SET_MEM 0x05
#define GET_MEM 0x85

#define GET_STAT 0xff

// Audio class request type (bmRequest type SETUPDAT[0])

#define OUT_CLASS_DEV 0x20
#define OUT_CLASS_INTERFACE 0x21
#define OUT_CLASS_ENDPOINT 0x22
#define OUT_CLASS_OTHER 0x23

#define IN_CLASS_DEV 0xA0
#define IN_CLASS_INTERFACE 0xA1
#define IN_CLASS_ENDPOINT 0xA2
#define IN_CLASS_OTHER 0xA3

// General USB request codes (bRequest SETUPDAT[1])

#define GET_STATUS 0x00
#define CLEAR_FEATURE 0x01
#define SET_FEATURE 0x03
#define SET_ADDRESS 0x05
#define GET_DESCRIPTOR 0x06
#define SET_DESCRIPTOR 0x07
#define GET_CONFIGURATION 0x08
#define SET_CONFIGURATION 0x09
#define GET_INTERFACE 0x0a
#define SET_INTERFACE 0x0b
#define SYNCH_FRAME 0x12

// General USB request type (bmRequest type SETUPDAT[0])

#define OUT_STD_DEV 0x00
#define OUT_STD_INTERFACE 0x01
#define OUT_STD_ENDPOINT 0x02
#define OUT_STD_OTHER 0x03

#define IN_STD_DEV 0x80
#define IN_STD_INTERFACE 0x81
#define IN_STD_ENDPOINT 0x82
#define IN_STD_OTHER 0x83

